## Changelog

### Tomcat 10.0.0-M10 (markt)

#### Catalina

- 55559: Add a new attribute, `localJndiResource`, that allows a UserDatabaseRealm to obtain a UserDatabase instance from the local (web application) JNDI context rather than the global JNDI context. This option is only useful when the Realm is defined on the Context. (markt)
- 64805: Correct imports used by `JMXProxyServlet`. (markt)
- Fix JNDIRealm pooling problems retrying on another bad connection. Any retries are made on a new connection, just like with the single connection scenario. Also remove all connections from the pool after an error. (remm)
- Remove the entry for `org.apache.tomcat.util.descriptor.tld.LocalStrings` from tomcat-embed-core's GraalVM tomcat-resource.json. It no more part of the jar since Fix unwanted JPMS dependency of embed-core on embed-jasper. (mgrigorov)
- Add `org.apache.coyote.http11.Http11Nio2Protocol` to the list of classes which could be instantiated via reflection in GraalVM. (mgrigorov)
- Add `JsonErrorReportValve` that extends the `ErrorReportValve` that returns response as JSON instead of HTML. (kfujino)
- Add GraalVM config for Tomcat JNI related classes. This makes it possible to use the APR protocol in GraalVM native images. To use it add the following to the native-image arguments: `-H:JNIConfigurationResources=META-INF/native-image/org.apache.tomcat.embed/tomcat-embed-core/tomcat-jni.json` (mgrigorov)
- JNDIRealm connections should only be created with the container classloader as the thread context classloader, just like for the JAAS realm. (remm)
- 64871: Log a warning if Tomcat blocks access to a file because it uses symlinks. (markt)
- Rename `JDBCStore` to `DataSourceStore` and remove bottlenecks for database backed session store. Legacy JDBC driver configuration is no longer supported. Patch submitted by Philippe Mouawad. (remm)

#### Coyote

- Refactor the HTTP/2 window update handling for padding in data frames to ensure that the connection window is correctly updated after a data frame with zero length padding is received. (markt)
- Fix processing of URIs with %nn encoded solidus characters when `encodedSolidusHandling` was set to `passthrough` and the encoded solidus was preceeded by other %nn encoded characters. Based on a pull request by willmeck. (markt)
- 63362: Add collection of statistics for HTTP/2, WebSocket and connections upgraded via the HTTP upgrade mechanism. (markt)
- Restore exception catch around Poller.events, as it would cause the NIO poller thread to exit. This is a regression caused when the Poller.events method was refactored. (remm)
- Provide messages for some `SocketTimeoutException` instances that did not have one. (markt)
- Avoid most of the thread pool use during NIO2 socket accept. Patch submitted by Anil Gursel. (remm)
- Add additional debug logging for I/O issues when communicating with the user agent. (markt)
- 64830: Fix concurrency issue in HPACK decoder. (markt)
- Fix a concurrency issue in the NIO connector that could cause newly created connections to be removed from the poller. (markt)

#### Jasper

- 64784: Don't include the time the Java file was generated as a comment when generating Java files for JSPs and/or tags if the Java file was created during pre-compilation. This is to aid repeatable builds. (markt)
- 64794: Security exception reading system property on JspRuntimeLibrary use. (remm)
- Add support for specifying Java 16 (with the value `16`) as the compiler source and/or compiler target for JSP compilation. If used with an ECJ version that does not support these values, a warning will be logged and the latest supported version will used. (markt)
- Update to the Eclipse JDT compiler 4.17. (markt)
- 64849: Correct JPMS metadata for the Jakarta Expression Langauge JARs to provide missing ServiceLoader information. (markt)

#### WebSocket

64848: Fix a variation of this memory leak when a write I/O error occurs on a non-container thread. (markt)

#### Web applications

- 64799: Added missing resources to host-manager web app. (isapir)
- 64797: Align manager.xml template file in Host-Manager with context.xml of real Manager web application. (isapir)
- Configure the examples web applications to set `SameSite=strict` for all cookies, including session cookies, created by the application. (markt)
- Configure the examples, Manager and Host Manager to use the HTTP header security filter with default settings apart from no HSTS header. Based on a suggestion by Debangshu Kundu. (markt)

#### Other

- Improvements to French translations. (remm)
- Improvements to Korean translations. (woonsan)
- Improvements to Russian translations. Provided by Azat. (markt)
- 64870: Update to bnd 5.3.0-SNAPSHOT to work around a JRE bug. (markt)

### 2020-10-09 Tomcat 10.0.0-M9 (markt)

#### Catalina

- The health check valve will now check the state of its associated containers to report availability. (remm)
- Fix race condition when saving and recycling session in `PersistentValve`. (kfujino)
- Remove the JDBCRealm. (markt)
- Correct numerous spellings throughout the code base. Based on a pull request from John Bampton. (markt)
- 64715: Add PasswordValidationCallback to the Jakarta Authentication implementation. Patch provided by Robert Rodewald. (markt)
- Allow using the utility executor for annotation scanning. Patch provided by Jatin Kamnani. (remm)
- 64751: Correct the JPMS module descriptor so the embedded JARs may be used with JPMS. (markt)
- When performing an incremental build, ensure bnd does not create unwanted JPMS dependencies between embedded JARs. (markt)
- Add a bloom filter to speed up archive lookup and improve deployment speed of applications with a large number of JARs. Patch provided by Jatin Kamnani. (remm)
- Throw `SQLException` instead of `NullPointerException` when failing to connect to the database. (kfujino)
- 64735: Ensure that none of the methods on a `ServletContext` instance always fail when running under a SecurityManager. Pull request provided by Kyle Stiemann. (markt)
- 64765: Ensure that the number of currently processing threads is tracked correctly when a web application is undeployed, long running requests are being processed and `renewThreadsWhenStoppingContext` is enabled for the web application. (markt)
- Improve the error messages when running under JPMS without the necessary options to enable reflection required by the memory leak prevention / detection code. (markt)
- When estimating the size of a resource in the static resource cache, include a specific allowance for the path to the resource. Based on a pull request by blueSky1825821. (markt)

#### Coyote

- Do not send an HTTP/2 PING frame to measure round-trip time when it is known that the HTTP/2 connection is not in a good state. (markt)
- Ensure HTTP/2 timeouts are processed for idle connections. (markt)
- 64743: Correct a regression introduced in 10.0.0-M7 that caused a `Connection: close` header to be added to the response if the Connector was configured with `maxSwallowSize=-1`. (markt)
- When logging HTTP/2 debug messages, use consistent formatting for stream identifiers. (markt)
- Correct some double counting in the code that tracks the number of in-flight asynchronous requests. The tracking enables Tomcat to shutdown gracefully when asynchronous processing is in use. (markt)
- Improve the error handling for the HTTP/2 connection preface when the Connector is configured with `useAsyncIO="true"`. (markt)
- Refactor the handling of closed HTTP/2 streams to reduce the heap usage associated with used streams and to retain information for more streams in the priority tree. (markt)
- Don't send the Keep-Alive response header if the connection has been explicitly closed. (markt)
- 64710: Avoid a `BufferOverflowException` if an HTTP/2 connection is closed while the parser still has a partial HTTP/2 frame in the input buffer. (markt)

#### Jasper

- Use lazy instantiation to improve the performance when working with listeners added to the `ELContext`. Pull request provided by Thomas Andraschko. (markt)

#### Web applications

- Configure the Manager and Host Manager web applications to set `SameSite=strict` for all cookies, including session cookies, created by the application. (markt)
- Update the Manager How-To in the documentation web application to clarify when a user may wish to deploy additional instances of the Manager web application. (markt)
- 64774: Review references to Tomcat 9 in the documentation web application and remove them or update them to refer to Tomcat 10 as appropriate. (markt)

#### Other

- Update to Commons Daemon 1.2.3. This adds support to jsvc for `--enable-preview` and native memory tracking (Procrun already supported these features), adds some additional debug logging and adds a new feature to Procrun that outputs the command to (re-)configure the service with the current settings. (markt)
- When building, only rebuild JAR files (including OSGi and JPMS metadata) if the contents has changed. (markt)
- Improvements to Chinese translations. Pull request provided by Yang Yang. (markt)
- Expand coverage of Russian translations. Pull request provided by Nikolay Gribanov. (markt)
- Update the OWB module to Apache OpenWebBeans 2.0.18. (remm)
- Update the CXF module to Apache CXF 3.4.0. (remm)
- Fix running service.bat when called from `$CATALINA_HOME`. (markt)
- Complete the fix for 63815. Users wishing to use system properties that require quoting with `catalina.sh` and the `debug` option must use a JRE that includes the fix for JDK-8234808. (markt)
- Improvements to Chinese translations. Provided by leeyazhou. (markt)
- Improvements to Czech translations. Provided by Dušan Hlaváč and Arnošt Havelka. (markt)
- Improvements to French translations. (remm)
- Improvements to Korean translations. (woonsan)
- Improvements to Spanish translations. Provided by Andrewlanecarr. (markt)

### 2020-09-14 Tomcat 10.0.0-M8 (markt)

#### Catalina

- 64582: Pre-load the `CoyoteOutputStream` class to prevent a potential exception when running under a security manager. Patch provided by Johnathan Gilday. (markt)
- 64593: If a request is not matched to a Context, delay issuing the 404 response to give the rewrite valve, if configured, an opportunity to rewrite the request. (remm/markt)
- Change top package name for generated embedded classes to avoid conflict with default host name on case insensitive filesystems. (remm)
- Add missing code generation for remaining digester rules. (remm)
- Add a dedicated loader for generated code to avoid dynamic class loading. (remm)
- Refactor the Default servlet to provide a single method that can be overridden (`generateETag()`) should a custom entity tag format be required. (markt)
- Improve the validation of entity tags provided with conditional requests. Requests with headers that contain invalid entity tags will be rejected with a 400 response code. Improve the matching algorithm used to compare entity tags in conditional requests with the entity tag for the requested resource. Based on a pull request by Sergey Ponomarev. (markt)
- Correct the description of the storage format for salted hashes in the Javadoc for `MessageDigestCredentialHandler` and refactor the associated code for clarity. Based on a patch provided by Milo van der Zee. (markt)
- Correct the path validation to allow the use of the file system root for the `docBase` attribute of a `Context`. Note that such a configuration should be used with caution. (markt)
- Added filtering expression for requests that are not supposed to use session in `PersistentValve`. (kfujino)
- Use the correct method to calculate session idle time in `PersistentValve`. (kfujino)
- Fix path used by the health check valve when it is not associated with a `Context`. (remm)
- 64712: The JASPIC authenticator now checks the `ServerAuthModule` for `jakarta.servlet.http.authType` and, if present, uses the value provided. Based on a patch by Robert Rodewald. (markt)
- 64713: The JASPIC authenticator now checks the value of `jakarta.servlet.http.registerSession` set by the `ServerAuthModule` when deciding whether or nor to register the session. Based on a patch by Robert Rodewald. (markt)

#### Coyote

- 57661: For requests containing the `Expect: 100-continue` header, add optional support to delay sending an intermediate 100 status response until the servlet reads the request body, allowing the servlet the opportunity to respond without asking for the request body. Based on a pull request by malaysf. (markt)
- Remove deprecated `CookieProcessor.generateHeader` method. (remm)
- Refactor the implementation of `ServletInputStream.available()` to provide a more accurate return value, particularly when end of stream has been reached. (markt)
- Refactor the stopping of the acceptor to ensure that the acceptor thread stops when a connector is started immediately after it is stopped. (markt)
- 64614: Improve compatibility with FIPS keystores. When a FIPS keystore is configured and the keystore contains multiple keys, the alias attribute will be ignored and the key used will be implementation dependent. (jfclere)
- 64621: Improve handling HTTP/2 stream reset frames received from clients. (markt)
- 64660: Avoid a potential NPE in the AprEndpoint if a socket is closed in one thread at the same time as the poller is processing an event for that socket in another. (markt)
- 64671: Avoid several potential NPEs introduced in the changes in the previous release to reduce the memory footprint of closed HTTP/2 streams. (markt)
- Refactor the HTTP/2 implementation to more consistently return a stream closed error if errors occur after a stream has been reset by the client. (markt)
- Improve handling of HTTP/2 stream level flow control errors and notify the stream immediately if it is waiting for an allocation when the flow control error occurs. (markt)
- Ensure that window update frames are sent for HTTP/2 connections to account for DATA frames containing padding including when the associated stream has been closed. (markt)
- Ensure that window update frames are sent for HTTP/2 connections and streams to account for DATA frames containing zero-length padding. (markt)
- 64710: Revert the changes to reduce the memory footprint of closed HTTP/2 streams as they triggered multiple regressions in the form of `NullPointerException`s. (markt)
- Ensure that the HTTP/2 overhead protection check is performed after each HTTP/2 frame is processed. (markt)

#### WebSocket

- Requests received via proxies may be marked as using the `ws` or `wss` protocol rather than `http` or `https`. Ensure that such requests are not rejected. PR provided by Ronny Perinke. (markt)
- 64848: Fix a potential issue where the write lock for a WebSocket connection may not be released if an exception occurs during the write. (markt)
- 64644: Add support for a read idle timeout and a write idle timeout to the WebSocket session via custom properties in the user properties instance associated with the session. Based on a pull request by sakshamverma. (markt)

#### Web applications

- Remove the localization of the text output of the Manager application list of contexts and the Host Manager application list of hosts so that the output is more consistent. PR provided by Holomark. (markt)
- Clean-up / standardize the XSL files used to generate the documentation. PR provided by John Bampton. (markt)
- 62723: Clarify the effects of some options for cluster `channelSendOptions`. Patch provided by Mitch Claborn. (schultz)
- Remove the out of date functional specification section from the documentation web application. (markt)
- Extracted CSS styles from the Manager we application for better code maintenance and replaced the GIF logo with SVG. (isapir)
- Add document for `PersistentValve`. (kfujino)

#### Other

- Correct a regression in the fix for 64540 and include `org.apache.tomcat.util.modeler.modules` and `org.apache.tomcat.util.net.jsse` in the list of exported packages. (markt)
- Remove the local copy of the `javax.transaction.xa` package which is only used during compilation. The package is provided by the JRE from Java 1.4 onwards so the local copy should be unnecessary. (markt)
- Rename the local copy of the `javax.xml.ws` package to `jakarta.xml.ws`. (markt)
- Improve the quality of the Japanese translations provided with Apache Tomcat. Includes contributions from Yuki Shira. (markt)
- 64645: Use a non-zero exit code if the `service.bat` does not complete normally. (markt)
- Update the internal fork of Apache Commons BCEL to 6.5.0. Code clean-up only. (markt)
- Update the internal fork of Apache Commons Codec to 53c93d0 (2020-08-18, 1.15-SNAPSHOT). Code clean-up. (markt)
- Update the internal fork of Apache Commons FileUpload to c25a4e3 (2020-08-26, 2.0-SNAPSHOT). Code clean-up and RFC 2231 support. (markt)
- Update the internal fork of Apache Commons Pool to 2.8.1. Code clean-up and improved abandoned pool handling. (markt)
- Update the internal fork of Apache Commons DBCP to 6d232e5 (2020-08-11, 2.8.0-SNAPSHOT). Code clean-up various bug fixes. (markt)
- Update the packaged version of the Tomcat Native Library to 1.2.25. (markt)

### 2020-07-05 Tomcat 10.0.0-M7 (markt)

#### Catalina

- Remove the error message on start if `java.io.tmpdir` is missing and add an explicit error message on application deployment when the sole feature that depends on it (anti-resource locking) is configured and can't be used. (markt)
- Implement a significant portion of the TLS environment variables for the rewrite valve. (remm)
- Add the Jakarta EE 9 schema. (markt)
- 64506: Correct a potential race condition in the resource cache implementation that could lead to `NullPointerException`s during class loading. (markt)
- Add `application/wasm` to the media types recognised by Tomcat. Based on a PR by Thiago Henrique Hüpner. (markt)
- Fix a bug in `HttpServlet` so that a `405` response is returned for an HTTP/2 request if the mapped servlet does implement the requested method rather than the more general `400` response. (markt)
- Add generated classes using Tomcat embedded as an optional replacement for the Catalina configuration files. (remm)
- 64541: Refactor the DTD used to validate `mbeans-descriptors.xml` files to avoid issues when XML entity expansion is limited or disabled. (markt)

#### Coyote

- Include a `Connection: close` HTTP header when committing a response and it is known that the `maxSwallowSize` limit is going to be exceeded. (markt)
- 64509: Correctly parse RFC 2109 version 1 cookies that use a comma as a separator between cookies when using the RFC 6265 cookie processor. Based on a patch by W J Carpenter. (markt)
- Fix the utility code that converted IPv6 addresses to a canonical form to correctly handle input addresses that ended with a pair of colons. Based on a patch by syarramsetty-skyhook. (markt)
- Correctly parse RFC 2109 version 1 cookies that have additional linear white space around cookie attribute names and values when using the RFC 6265 cookie processor. (markt)
- Once an HTTP/2 stream has been closed, ensure that the code that cleans up references that are no longer required is called. (markt)
- Reduce the memory footprint of closed HTTP/2 streams. (markt)
- Ensure that the HTTP/1.1 processor is correctly recycled when a direct connection to h2c is made. (markt)

#### Jasper

- Update the JSP document validation to permit `3.0` as a valid version attribute for the `<jsp-root>` element. (markt)

#### Cluster

- 64560: Refactor the replication of a changed session ID for a replicated session so that the list of changes associated with the session is not reset when the session ID changes. (markt)

#### WebSocket

- 64563: Add additional validation of payload length for WebSocket messages. (markt)
- Correct the calculation of payload length when four or more bytes are required to represent the payload length. (markt)

#### Web Applications

- Update all web applications to use the Jakarta EE 9 schema for web.xml. (markt)

#### Other

- Fix incorrect version format in OSGi manifests. Patch provided by Raymond Augé. (markt)
- 64513: Remove bndlib from dependencies as it is not required. Pull request provided by Raymond Augé. (markt)
- 64515: Bnd files don't need to be filtered (save some work). Pull request provided by Raymond Augé. (markt)
- Update the OWB module to Apache OpenWebBeans 2.0.17. (remm)
- 64514: Fixes some missing class dependency issues in bootstrap to address packaging/dependency concerns for JPMS and OSGi. Pull request provided by Raymond Augé. (markt)
- 64521: Avoid moving i18n translations into classes dir since they are packaged into separate jars. Pull request provided by Raymond Augé. (markt)
- 64522: Package jars in effective dependency order. Pull request provided by Raymond Augé. (markt)
- Store common build details in a shared build-defaults.bnd. Pull request provided by Raymond Augé. (markt)
- 64532: Update to bnd 5.1.1. Pull request provided by Raymond Augé. (markt)
- 64540: Switch from bndwrap task to bnd task, begin generating a better manifest and make sure the resulting jar contents are correct. Pull request provided by Raymond Augé. (markt)
- 64544: Add built libs to the bnd classpath for introspection. Pull request provided by Raymond Augé. (markt)
- Improve the quality and expand the coverage of the French translations provided with Apache Tomcat. (remm)
- 64548: Generate JPMS metadata. (rotty3000)

### 2020-06-07 Tomcat 10.0.0-M6 (markt)

#### Catalina

- 64432: Correct a refactoring regression that broke handling of multi-line configuration in the RewriteValve. Patch provided by Jj. (markt)
- Fix use of multiple parameters when defining RewriteMaps. (remm/fschumacher)
- Add the special internal rewrite maps for case modification and escaping. (remm/fschumacher)
- Correct a regression in an earlier fix that broke the loading of configuration files such as keystores via URIs on Windows. (markt)
- Implement a few rewrite SSL env that correspond to Servlet request attributes. (remm)
- 64442: Be more flexible with respect to the ordering of groups, roles and users in the `tomcat-users.xml` file. (fschumacher)

#### Coyote

- Add support for ALPN on recent OpenJDK 8 releases. (remm)
- 64467: Improve performance of closing idle HTTP/2 streams. (markt)
- Expose server certificate through the `SSLSupport` interface. (remm)
- 64483: Log a warning if an AJP request is rejected because it contains an unexpected request attribute. (markt)
- 64485: Fix possible resource leak getting last modified from `ConfigurationSource.Resource`. (remm)

#### Jasper

- Update the Jakarta Server Pages API implementation to align with specification updates to use generics and add missing `@Deprecated` annotations. (markt)
- 64488: Ensure that the ImportHandler from the Expression Language API is able to load classes from the Java runtime when running under a SecurityManager. Based on a patch by Volodymyr Siedleck. (markt)

#### WebSocket

- Add default implementations for `init()` and `destroy()` to the `Encoder` and `Decoder` interfaces. (markt)
- Consistently throw a `DeploymentException` when an invalid endpoint path is specified and catch invalid endpoint paths earlier. (markt)
- Include the target URL in the log message when a WebSocket connection fails. (markt)

#### Other

- Update the list of known `Charset`s in the `CharsetCache` to include `ISO-8859-16`, added in OpenJDK 15. (markt)
- Improve the quality and expand the coverage of the French translations provided with Apache Tomcat. (remm)
- 64430: Add support for the `CATALINA_OUT_CMD` environment variable that defines a command to which captured stdout and stderr will be redirected. Patch provided by Harald Dunkel. (markt)
- Switch from the unsupported Maven Ant Tasks to the supported Maven Resolver Ant Tasks to upload artifacts to the ASF Maven repository (and from there to Maven Central). (markt)
- Update dependency on bnd to 5.1.0. (markt)

### 2020-05-11 Tomcat 10.0.0-M5 (markt)

#### Catalina

- Remove `useAprConnector` flag from `AprLifecycleListener` so that the only way to use the APR connectors is to set the full class name. (remm)
- 59203: Before calling `Thread.stop()` (if configured to do so) on a web application created thread that is not stopped by the web application when the web application is stopped, try interrupting the thread first. Based on a pull request by Govinda Sakhare. (markt)
- 62912: Don't mutate an application provided content header if it does not contain a charset. Also remove the outdated workaround for the buggy Adobe Reader 9 plug-in for IE. (markt)
- Remove the `reloadable` attribute from the `Loader` interface as it is duplicated on the `Context` interface. (markt)
- Reduce reflection use and remove AJP specific code in the Connector. (remm/markt/fhanik)
- Rework the fix for 64021 to better support web applications that use a custom class loader that loads resources from non-standard locations. (markt)
- Remove redundant sole path/URI from error page message on SC_NOT_FOUND. (michaelo)
- Log a warning if a `CredentialHandler` instance is added to an instance of the `CombinedRealm` (or a sub-class) as the `CombinedRealm` doesn't use a configured `CredentialHandler` and it is likely that a configuration error has occurred. (markt)
- Add more descriptive error message in DefaultServlet for SC_NOT_FOUND. (michaelo)
- 64309: Improve the regular expression used to search for class loader repositories when bootstrapping Tomcat. Pull request provided by Paul Muriel Biya-Bi. (markt)
- 64384: Fix multipart configuration ignoring some parameters in some cases. (schultz)
- 64386: WebdavServlet does not send "getlastmodified" property for resource collections. (michaelo)
- Remove reason phrase on WebDAV Multi-Status (207) response. (michaelo)
- 64398: Change default value separator for property replacement to `:-` due to possible conflicts. The syntax is now `${name:-default}`. (remm)
- Improve validation of storage location when using FileStore. (markt)

#### Coyote

- Move `SocketProperties` mbean to its own type rather than use a subType to improve robustness with tools. (remm)
- Include the problematic data in the error message when reporting that the provided request line contains an invalid component. (markt)
- Improve the handling of requests that use an expectation. Do not disable keep-alive where the response has a non-2xx status code but the request body has been fully read. (rjung/markt)
- 64403: Ensure that compressed HTTP/2 responses are not sent with a content length header appropriate for the original, uncompressed response. (markt)

#### Jasper

- Remove redundant sole path/URI from error page message on SC_NOT_FOUND. (michaelo)
- Add more descriptive error message in DefaultServlet for SC_NOT_FOUND. (michaelo)
- 64373: When a tag file is packaged in a WAR and then that WAR is unpacked in `/WEB-INF/classes` ensure that the tag file can still be found. Patch provided by Karl von Randow. (markt)
- Ensure that the Jasper code that interfaces with the Eclipse Compiler for Java (ECJ) enables Jasper to compile JSPs using ECJ 4.14 onwards when the JSPs have inner classes. (markt)

#### Cluster

- Refactor Tribes BufferPool and add the `org.apache.catalina.tribes.io.BufferPool.DEFAULT_POOL_SIZE` system property to configure its size. (remm)
- Remove java.io based Tribes receiver and sender, in favor of NIO which was the default. (remm)

#### Web applications

- Fix the saving of a Context configuration file via the scripting interface of the Manager web application. (markt)
- Add a section to the TLS Connector documentation on different key store types and how to configure them. (markt)

#### Other

- Update JUnit to version 4.13. (markt)
- Add missing entries to test class path in sample NetBeans configuration files. Patch provided by Brian Burch. (markt)
- Refactor to use parameterized `Collection` constructors where possible. Pull request provided by Lars Grefer. (markt)
- Refactor to use empty arrays with `Collections.toArray()`. Pull request provided by Lars Grefer. (markt)
- Refactor loops with a condition to exit as soon as the condition is met. Pull request provided by Lars Grefer. (markt)
- Refactor bulk addition to collections to use `addAll()` rather than a loop. Pull request provided by Lars Grefer. (markt)
- Expand the coverage of the Chinese translations provided with Apache Tomcat. Contributions provided by winsonzhao, ZhangJieWen and Lee Yazhou. (markt)
- Improve the quality and expand the coverage of the French translations provided with Apache Tomcat. (remm)
- Improve the quality of the Japanese translations provided with Apache Tomcat. Includes contributions from Yoshy. (markt)
- Improve the quality of the German translations provided with Apache Tomcat. (markt)
- Update the packaged version of the Tomcat Native Library to 1.2.24. (markt)
- Refactor to use enhanced for loops where possible. Pull request by Lars Grefer. (markt)
- Improve IDE support for IntelliJ IDEA. Patch provided by Lars Grefer. (markt)
- Improve the coverage and quality of the Korean translations provided with Apache Tomcat. (woonsan)
- Update dependency on bnd to 5.0.1. (markt)

### 2020-04-08 Tomcat 10.0.0-M4 (markt)

#### Catalina

- Ensure all URL patterns provided via web.xml are %nn decoded consistently using the encoding of the web.xml file where specified and UTF-8 where no explicit encoding is specified. (markt)
- Allow a comma separated list of class names for the `org.apache.tomcat.util.digester.PROPERTY_SOURCE` system property. (remm)
- 64149: Avoid NPE when using the access log valve without a pattern. (remm)
- 64226: Reset timezone after parsing a date since the date format is reused. Test case submitted by Gary Thomas. (remm)
- 64247: Using a wildcard for `jarsToSkip` should not override a possibly present `jarsToScan`. Based on code submitted by Iridias. (remm)
- Refactor DefaultServlet to avoid using an internal Range structure that is duplicated from the parsing result. (remm)
- Remove `org.apache.catalina.connector.CoyoteAdapter.ALLOW_BACKSLASH` system property, replaced by the `allowBackslash` attribute on the Connector. (remm)
- Remove `org.apache.catalina.connector.Response.ENFORCE_ENCODING_IN_GET_WRITER` system property, replaced by the `enforceEncodingInGetWriter` attribute on the Connector. (remm)
- Remove `org.apache.catalina.session.StandardSession.ACTIVITY_CHECK` system property, replaced by the `sessionActivityCheck` attribute on the Manager. (remm)
- Remove `org.apache.catalina.session.StandardSession.LAST_ACCESS_AT_START` system property, replaced by the `sessionLastAccessAtStart` attribute on the Manager. (remm)
- Remove `org.apache.catalina.core.StandardHostValve.ACCESS_SESSION` system property, replaced by the `alwaysAccessSession` attribute on the Context. (remm)
- Remove `org.apache.catalina.core.ApplicationContext.GET_RESOURCE_REQUIRE_SLASH` system property, replaced by the `contextGetResourceRequiresSlash` attribute on the Context. (remm)
- Remove `org.apache.catalina.core.ApplicationDispatcher.WRAP_SAME_OBJECT` system property, replaced by the `dispatcherWrapsSameObject` attribute on the Context. (remm)
- 64265: Fix ETag comparison performed by the default servlet. The default servlet always uses weak comparison. (markt)
- Remove `org.apache.catalina.authenticator.Constants.SSO_SESSION_COOKIE_NAME` system property, replaced by the `cookieName` attribute on the SSO valve. (remm)
- Add support for default values when using `${...}` property replacement in configuration files. Based on a pull request provided by Bernd Bohmann. (markt)

#### Coyote

- When closing a NIO channel, avoid canceling keys as a workaround for deadlocks when running on Java 11. Excessive internal NIO synchronization on channel close is resolved starting with this Java version. (remm)
- When configuring an HTTP Connector, ensure that the encoding specified for `URIEncoding` is a superset of US-ASCII as required by RFC7230. (markt)
- Avoid always retrieving the NIO poller selection key when processing to reduce sync. (remm)
- 64240: Ensure that HTTP/0.9 requests that contain additional data on the request line after the URI are treated consistently. Such requests will now always be treated as HTTP/1.1. (markt)
- Expose the HTTP/2 connection ID and stream ID to applications via the request attributes `org.apache.coyote.connectionID` and `org.apache.coyote.streamID` respectively. (markt)
- Replace the system property `org.apache.tomcat.util.buf.UDecoder.ALLOW_ENCODED_SLASH` with the Connector attribute `encodedSolidusHandling` that adds an additional option to pass the `%2f` sequence through to the application without decoding it in addition to rejecting such sequences and decoding such sequences. (markt)
- Expose the associated `HttpServletRequest` to the `CookieProcessor` when generating a cookie header so the header can be tailored based on the properties of the request, such as the user agent, if required. Based on a patch by Lazar Kirchev. (markt)

#### Jasper

- Update to the Eclipse JDT compiler 4.15. (markt)
- Add support for specifying Java 14 (with the value `14`) and Java 15 (with the value `15`) as the compiler source and/or compiler target for JSP compilation. If used with an ECJ version that does not support these values, a warning will be logged and the latest supported version will used. (markt)
- Remove Jasper configuration using system properties and replace them by a new set of JSP Servlet init parameters. (remm)

#### Web applications

- Correct the documentation web application to remove references to the `org.apache.catalina.STRICT_SERVLET_COMPLIANCE` system property changing the default for the `URIEncoding` attribute of the Connector. (markt)
- Correct the documentation web application to remove references to the `org.apache.tomcat.util.buf.UDecoder.ALLOW_ENCODED_SLASH` system property changing how the sequence `%5c` is interpreted in a URI. (markt)

#### Tribes

- Remove support for the deprecated system property `org.apache.catalina.tribes.dns_lookups`. The default value of `false` will now always be used. (markt)

#### Other

- Improve the quality and expand the coverage of the French translations provided with Apache Tomcat. Contribution provided by Tom Bens. (remm)
- Expand the coverage of the Chinese translations provided with Apache Tomcat. Contribution provided by Lee Yazhou. (markt)
- 64270: Set the documented default umask of `0027` when using jsvc via `daemon.sh` and allow the umask used to be configured via the `UMASK` environment variable as it is when using `catalina.sh`. (markt)
- Update the OWB module to Apache OpenWebBeans 2.0.16. (remm)
- Update the CXF module to Apache CXF 3.3.6. (remm)
- Remove the `LOGGING_CONFIG` environment variable and replace it with the `CATALINA_LOGGING_CONFIG` environment variable to avoid clashes with other components that use `LOGGING_CONFIG`. (markt)

### 2020-03-16 Tomcat 10.0.0-M3 (markt)

#### Coyote

- 64202: Use a loop on NIO blocking reads, as it is possible zero bytes are produced by a network read. (markt/remm)
- 64210: Correct a regression in the improvements to HTTP header validation that caused requests to be incorrectly treated as invalid if a `CRLF` sequence was split between TCP packets. Improve validation of request lines, including for HTTP/0.9 requests. (markt)

#### Other

- 64206: Correct a regression introduced in 10.0.0-M1 that meant that the HTTP port specified when using the Windows Installer was ignored and 8080 was always used. (markt)

### not released Tomcat 10.0.0-M2 (markt)

#### Catalina

- Refactor `HttpServlet.doOptions()` to improve performance. (markt)
- Disable StandardManager session persistence by default. It can be enabled back in `context.xml`. (remm)
- Add extension point to DeltaSession to improve subclassing. Patch provided by ThStock. (schultz)
- 64153: Ensure that the parent for the web application class loader is set consistently. (markt)
- 64166: Ensure that the names returned by `HttpServletResponse.getHeaderNames()` are unique. (markt)
- Rename `org.apache.tomcat.util.digester.Digester$EnvironmentPropertySource` to `org.apache.tomcat.util.digester.EnvironmentPropertySource`. Patch provided by Bernd Bohmann. (markt)
- 63286: Resolve inconsistencies with access log valve. This changes the element API to use a nanosecond resolution elapsed time argument. (remm)
- Add new attribute `persistAuthentication` to both `StandardManager` and `PersistentManager` to support authentication persistence. Patch provided by Carsten Klein. (markt)
- 64184: Avoid repeated log messages if a `MemoryUserDatabase` is configured but the specified configuration file is missing. (markt)
- 64189: Expose the web application version String as a `ServletContext` attribute named `org.apache.catalina.webappVersion`. (markt)

#### Coyote

- Fix support of native jakarta servlet attributes in AJP connector. (remm)
- 56966: Add use of System.nanoTime to track request execution time. (remm)
- 64141: If using a CA certificate, remove a default value for the truststore file when not using a JSSE configuration. (remm)
- Improve robustness of OpenSSLEngine shutdown. Based on code submitted by Manuel Dominguez Sarmiento. (remm)
- Add the TLS request attributes used by IIS to the attributes that an AJP Connector will always accept. (markt)
- A zero length AJP secret will now behave as if it has not been specified. (remm)
- 64188: If an error occurs while committing or flushing the response when using a multiplexing protocol like HTTP/2 that requires the channel to be closed but not the connection, just close the channel and allow the other channels using the connection to continue. Based on a suggestion from Alejandro Anadon. (markt)
- Correct the semantics of `getEnableSessionCreation` and `setEnableSessionCreation` for `OpenSSLEngine`. Pull request provided by Alexander Scheel. (markt)
- 64192: Correctly handle case where unread data is returned to the read buffer when the read buffer is non empty. Ensure a gathering TLS read stops once the provided ByteBuffers are full or no more data is available. (markt)
- Allow async requests to complete cleanly when the Connector is paused before `complete()` is called on a container thread. (markt)

#### Cluster

- Allow configuring the `DNSMembershipProvider` using the `dns` alias. Submitted by Bernd Bohmann. (remm)

#### Web applications

- Expand the documentation for the `address` attribute of the AJP Connector and document that the AJP Connector also supports the `ipv6v6only` attribute with the APR/Native implementation. (markt)

#### Other

- Update the OWB module to Apache OpenWebBeans 2.0.15. (remm)
- Update the CXF module to Apache CXF 3.3.5. (remm)
- Expand the coverage of the Korean translations provided with Apache Tomcat. Contributions provided by B. Cansmile Cha. (markt)
- Expand the coverage of the French translations provided with Apache Tomcat. (remm)
- 64190: Add support for specifying milliseconds (using `S`, `SS` or `SSS`) in the timestamp used by JULI's `OneLineFormatter`. (markt)

### 2020-02-20 Tomcat 10.0.0-M1 (markt)

#### General

This release contains all of the changes upto and including those in Apache Tomcat 9.0.31 plus the additional changes listed below. (markt)

#### Catalina

- Refactor recycle facade system property into a new connector attribute named `discardFacades` and enable it by default. (remm)
- Update to Jakarta Servlet 5.0, Jakarta Server Pages 3.0. Jakarta Expression Language 4.0, Jakarta WebSocket 2.0, Jakarta Authentication 2.0 and Jakarta Annotations 2.0. (markt)
- Remove GenericPrincipal.getPassword. The credentials should remain managed by the realm. (remm)
- Add connection pooling to JNDI realm. (remm)
- Use `<request-character-encoding>` and `<response-character-encoding>` in `conf/web.xml` to set the default request and response character encodings to UTF-8. (markt)
- Store config compatibility with HostWebXmlCacheCleaner listener. (remm)
- Modify the `RewriteValve` to use `ServletRequest.getServerName()` to populate the `HTTP_HOST` variable rather than extracting it from the `Host` header as this allows HTTP/2 to be supported. (markt)
- Switch Tomcat embedded to loading MIME type mappings from a property file generated from the default `web.xml` so the MIME type mappings are consistent regardless of how Tomcat is started. (markt)
- Missing store config attributes for Resources elements. (remm)

#### Coyote

- Update endpoint cache sizes defaults. (remm)
- Remove unused NIO blocking selector. (remm)
- When using an AJP Connector, convert Java Servlet specific request attributes to the Jakarta Servlet equivalent. (markt)
- When reporting / logging invalid HTTP headers encode any non-printing characters using the 0xNN form. (markt)
- Remove duplication of HTTP/1.1 configuration on the HTTP/2 UpgradeProtocol element. Configuration from the main Connector element will now be used. (remm)
- When the NIO or APR/native connectors were configured with `useAsyncIO="true"` and a zero length read or write was performed, the read/write would time out rather than return immediately. (markt)

#### Jasper

- Parameterize JSP version and API class names in localization messages to allow simpler re-use between major versions. (markt)
- Ensure that TLD files listed in the `jsp-config` section of `web.xml` that are registered in the `uriTldResourcePathMap` with the URI specified in `web.xml` are also registered with the URI in the TLD file if it is different. Patch provided by Markus Lottmann. (markt)

#### Cluster

- Fix cloud environment lookup order and add a dedicated `DNS_MEMBERSHIP_SERVICE_NAME` environment for use with the DNS membership provider. Submitted by Bernd Bohmann. (remm)

#### Other

- 53620: JULI now only creates logging files when there is a log entry to write. Based on a patch by Karol Bucek. (markt)
- Update implemented specification version information in a few places where it has not been updated for Jakarta EE 9. (markt)
- Expand the coverage of the French translations provided with Apache Tomcat. (remm)
- Expand the coverage of the Chinese translations provided with Apache Tomcat. Contribution provided by BoltzmannWxd. (markt)